package gov.llnl.babel.ast;

import gov.llnl.babel.parsers.sidl2.ParseTreeNode;
import gov.llnl.babel.visitor.Visitor;

public class ArgumentList extends NodeList {

  public ArgumentList(ParseTreeNode src, ASTNode parent) {
    super(src, parent);
  }

  public NodeList cloneEmpty() {
    ArgumentList newList = new ArgumentList(null, d_parent);
    newList.d_firstToken = d_firstToken;
    newList.d_lastToken = d_lastToken;
    return newList;
  }

  public boolean addArgument(Argument arg) { 
    if (d_firstToken == null ) { 
      d_firstToken = arg.getFirstToken();
    }
    d_lastToken = arg.getLastToken();
    return d_list.add(arg);
  }
  
  public Object accept(Visitor v, Object data) {
    return v.visitArgumentList( this, data );
  }

}
