//
// File:        SemanticChecker.java
// Package:     
// Copyright:   (c) 2006 The Regents of the University of California
// Release:     $Name$
// Revision:    @(#) $Revision: 5496 $
// Date:        $Date: 2006-05-18 21:34:19 -0700 (Thu, 18 May 2006) $
// Description: This Visitor does a number of semantic checks on the AST. It
// is done last so that the inheritance hierarchy will be fully represented
// in the SymbolTable. 

package gov.llnl.babel.visitor;

import gov.llnl.babel.msg.MsgList;
import gov.llnl.babel.ast.ClassType;

/**
 * Iterates over a AST a second time to decorate a primed SymbolTable
 * with all the details about classes, interfaces, and structs
 * 
 * Type resolution is largely performed in this stage.
 * 
 * @see gov.llnl.babel.visitor.SymbolTablePrimer
 * @author kumfert
 */
public class SemanticChecker extends Visitor {
  
  protected gov.llnl.babel.symbols.SymbolTable d_st;
  
  protected MsgList d_msgs;

  public SemanticChecker(MsgList msgs) {
    super();
    d_msgs = msgs;
    d_st = gov.llnl.babel.symbols.SymbolTable.getInstance();
  }
  
  public Object visitClassType(ClassType node, Object data) { 
    return data;
  }
}
