#
# File:          Fib_Impl.py
# Symbol:        ExceptionTest.Fib-v1.0
# Symbol Type:   class
# Babel Version: 1.0.0
# Description:   Implementation of sidl class ExceptionTest.Fib in Python.
# 
# WARNING: Automatically generated; changes will be lost
# 
#


"""This class holds the method <code>getFib</code> that generates the
requested Fibonacci numbers.
"""

# DO-NOT-DELETE splicer.begin(_initial)
# Put your code here...
# DO-NOT-DELETE splicer.end(_initial)

import ExceptionTest.Fib
import ExceptionTest.FibException
import ExceptionTest.NegativeValueException
import sidl.BaseClass
import sidl.BaseInterface
import sidl.ClassInfo
import sidl.RuntimeException
import sidl.NotImplementedException

# DO-NOT-DELETE splicer.begin(_before_type)
import ExceptionTest.TooDeepException
import ExceptionTest.TooBigException
# DO-NOT-DELETE splicer.end(_before_type)

class Fib:
  """\
This class holds the method <code>getFib</code> that generates the
requested Fibonacci numbers.
"""

  # All calls to sidl methods should use __IORself

  # Normal Babel creation pases in an IORself. If IORself == None
  # that means this Impl class is being constructed for native delegation
  def __init__(self, IORself = None):
    if (IORself == None):
      self.__IORself = ExceptionTest.Fib.Fib(impl = self)
    else:
      self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    # Put your code here...
    # DO-NOT-DELETE splicer.end(__init__)

  # Returns the IORself (client stub) of the Impl, mainly for use
  # with native delegation
  def _getStub(self):
    return self.__IORself

  def getFib(self, n, max_depth, max_value, depth):
    #
    # sidl EXPECTED INCOMING TYPES
    # ============================
    # int n
    # int max_depth
    # int max_value
    # int depth
    #

    #
    # sidl EXPECTED RETURN VALUE(s)
    # =============================
    # int _return
    #

    """\
<p>
Generate the requested Fibonacci number or generate exceptions if
the input Fibonacci number is invalid or if any of the maximum depth
or maximum value parameters are exceeded.  The last argument of the
method should be zero.
</p>
<p>
The algorithm should be similar to the <code>Java</code> code below.
</p>
<pre>
public int getFib(int n, int max_depth, int max_value, int depth)
throws NegativeValueException, FibException {

if (n < 0) {
throw new NegativeValueException(\"n negative\");

} else if (depth > max_depth) {
throw new TooDeepException(\"too deep\");

} else if (n == 0) {
return 1;

} else if (n == 1) {
return 1;

} else {
int a = getFib(n-1, max_depth, max_value, depth+1);
int b = getFib(n-2, max_depth, max_value, depth+1);
if (a + b > max_value) {
throw new TooBigException(\"too big\");
}
return a + b;
}
} 
</pre>
"""
    # DO-NOT-DELETE splicer.begin(getFib)
    if (n < 0):
      ex = ExceptionTest.NegativeValueException.NegativeValueException()
      ex.setNote("n negative")
      ex.add(__name__, 0, "ExceptionTest.Fib.getFib")
      raise ExceptionTest.NegativeValueException._Exception, ex
    if (depth > max_depth):
      ex =  ExceptionTest.TooDeepException.TooDeepException()
      ex.setNote("too deep")
      ex.add(__name__, 0, "ExceptionTest.Fib.getFib")
      raise ExceptionTest.FibException._Exception, ex
    if (n == 0):
      return 1
    if (n == 1):
      return 1
    try:
      a = self.__IORself.getFib(n - 1, max_depth, max_value, depth + 1)
      b = self.__IORself.getFib(n - 2, max_depth, max_value, depth + 1)
      if (a + b > max_value):
        ex = ExceptionTest.TooBigException.TooBigException()
        ex.setNote("too big")
        ex.add(__name__, 0, "ExceptionTest.Fib.getFib")
        raise ExceptionTest.FibException._Exception, ex
      return a + b
    except ExceptionTest.FibException._Exception, exc:
      exc.exception.add(__name__, 0, "ExceptionTest.Fib.getFib")
      raise ExceptionTest.FibException._Exception, exc
    # DO-NOT-DELETE splicer.end(getFib)

# DO-NOT-DELETE splicer.begin(_final)
# Put your code here...
# DO-NOT-DELETE splicer.end(_final)
