!
! File:       argstest.F90
! Copyright:  (c) 2002 The Regents of the University of California
! Revision:   @(#) $Revision: 5121 $
! Date:       $Date: 2005-12-09 14:41:13 -0800 (Fri, 09 Dec 2005) $
! Description:Exercise the FORTRAN interface
!
!
#include "hooks_Basics_fAbbrev.h"
#include "synch_RegOut_fAbbrev.h"
#include "synch_ResultType_fAbbrev.h"

subroutine starttest(number)
  use sidl
  use synch_RegOut
  use sidl_BaseInterface
  implicit none
  integer (kind=sidl_int) :: number
  type(synch_RegOut_t) :: tracker
  type(sidl_BaseInterface_t) :: throwaway_exception
  call getInstance(tracker, throwaway_exception)
  call startPart(tracker, number, throwaway_exception)
  call deleteRef(tracker, throwaway_exception)
end subroutine starttest

subroutine reporttest(test, number, python)
  use sidl
  use synch_RegOut
  use sidl_BaseInterface
  use synch_ResultType
  implicit none
  integer (kind=sidl_int) :: number
  logical                             :: test, python
  type(synch_RegOut_t) :: tracker
  type(sidl_BaseInterface_t) :: throwaway_exception
  call getInstance(tracker, throwaway_exception)
  if (test) then
     call endPart(tracker, number, PASS, throwaway_exception)
  else
     if (python) then
        call endPart(tracker, number, XFAIL, throwaway_exception)
     else
        call endPart(tracker, number, FAIL, throwaway_exception)
     endif
  endif
  call deleteRef(tracker, throwaway_exception)
  number = number + 1
end subroutine reporttest

subroutine testhooks(test)
  use sidl
  use hooks_Basics
  implicit none
  type(hooks_Basics_t) :: obj
  integer (kind=sidl_int)  :: test, ret, b, c
  logical                  :: out, inout, retval
  type(sidl_BaseInterface_t) :: throwaway_exception

  inout = .true.
  call new(obj, throwaway_exception)
  !
  ! Until a better solution can be found to deal with what appears to be
  ! a residual set_hooks overloading problem, set hooks the old-fashioned
  ! way.  (Note: Static was working but non-static was not.)
  ! 
  call aStaticMeth(test, b, c, ret, throwaway_exception);
  test = test + 1
  call aNonStaticMeth(obj, test, b, c, ret, throwaway_exception);

  call deleteRef(obj, throwaway_exception)
end subroutine testhooks

program hookstest
  use sidl
  use synch_RegOut
  use sidl_BaseInterface
  integer (kind=sidl_int) :: test
  character (len=80)             :: language
  type(synch_RegOut_t) :: tracker
  type(sidl_BaseInterface_t) :: throwaway_exception
  language = ' '
  if (IArgc() .eq. 1) then
     call GetArg(1, language)
  endif
  call getInstance(tracker, throwaway_exception)
  test = 1
  call setExpectations(tracker, 2, throwaway_exception)
  call writeComment(tracker, 'hooks tests', throwaway_exception)
  call testhooks(test)
  call close(tracker, throwaway_exception)
  call deleteRef(tracker, throwaway_exception)
end program hookstest
